# -*- coding: utf-8 -*-
#Библиотеки, които използват python и Kodi в тази приставка
import re
import sys
import os
import urllib
import urllib2
import xbmc
import xbmcgui
import xbmcplugin
import xbmcaddon
import random
import json

#Място за дефиниране на константи, които ще се използват няколкократно из отделните модули
__addon_id__= 'plugin.video.imedia'
__Addon = xbmcaddon.Addon(__addon_id__)
searchicon = xbmc.translatePath(__Addon.getAddonInfo('path') + "/resources/search.png")

MUA = 'Mozilla/5.0 (Linux; Android 5.0.2; bg-bg; SAMSUNG GT-I9195 Build/JDQ39) AppleWebKit/535.19 (KHTML, like Gecko) Version/1.0 Chrome/18.0.1025.308 Mobile Safari/535.19' #За симулиране на заявка от мобилно устройство
UA = 'Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:50.0) Gecko/20100101 Firefox/50.0' #За симулиране на заявка от  компютърен браузър

#Извличане на сесиен token
req = urllib2.Request('http://imedia.bnt.bg')
req.add_header('User-Agent', UA)
response = urllib2.urlopen(req)
data=response.read()
response.close()
        
match = re.compile('programataFrontVars = (.+?);').findall(data)
for found in match:
    jsonrsp = json.loads(found)
    ajaxurl = jsonrsp['ajaxurl'].decode('ascii', 'ignore').encode('ascii', 'ignore')
    nfn = jsonrsp['now_front_nonce'].decode('ascii', 'ignore').encode('ascii', 'ignore')


#Меню с директории в приставката
def CATEGORIES():
        addDir('Търсене','http://imedia.bnt.bg',11,searchicon)
        addDir('А-Я','http://imedia.bnt.bg',1,'DefaultFolder.png')
        addDir('Канали','http://imedia.bnt.bg',2,'DefaultFolder.png')
        addDir('Категории','http://imedia.bnt.bg',3,'DefaultFolder.png')
        addDir('На живо','http://epg.kodibg.org/brigadatv.php',6,'DefaultFolder.png')
        addDir('На Запис','http://imedia.bnt.bg/programa',4,'DefaultFolder.png')
        addDir('Архив','http://imedia.bnt.bg/newfrontpage/arhiv',8,'DefaultFolder.png')
        #addDir('','',1,'')
        



#Списък на предаванията по азбучен ред
def AQLIST(url):
        addDir('А','А',10,'DefaultFolder.png')
        addDir('Б','Б',10,'DefaultFolder.png')
        addDir('В','В',10,'DefaultFolder.png')
        addDir('Г','Г',10,'DefaultFolder.png')
        addDir('Д','Д',10,'DefaultFolder.png')
        addDir('Е','Е',10,'DefaultFolder.png')
        addDir('Ж','Ж',10,'DefaultFolder.png')
        addDir('З','З',10,'DefaultFolder.png')
        addDir('И','И',10,'DefaultFolder.png')
        addDir('Й','Й',10,'DefaultFolder.png')
        addDir('К','К',10,'DefaultFolder.png')
        addDir('Л','Л',10,'DefaultFolder.png')
        addDir('М','М',10,'DefaultFolder.png')
        addDir('Н','Н',10,'DefaultFolder.png')
        addDir('О','О',10,'DefaultFolder.png')
        addDir('П','П',10,'DefaultFolder.png')
        addDir('Р','Р',10,'DefaultFolder.png')
        addDir('С','С',10,'DefaultFolder.png')
        addDir('Т','Т',10,'DefaultFolder.png')
        addDir('У','У',10,'DefaultFolder.png')
        addDir('Ф','Ф',10,'DefaultFolder.png')
        addDir('Х','Х',10,'DefaultFolder.png')
        addDir('Ц','Ц',10,'DefaultFolder.png')
        addDir('Ч','Ч',10,'DefaultFolder.png')
        addDir('Ш','Ш',10,'DefaultFolder.png')
        addDir('Щ','Щ',10,'DefaultFolder.png')
        addDir('Ь','Ь',10,'DefaultFolder.png')
        addDir('Ъ','Ъ',10,'DefaultFolder.png')
        addDir('Ю','Ю',10,'DefaultFolder.png')
        addDir('Я','Я',10,'DefaultFolder.png')
        
        
        
        
       


#Разлистване на предаванията, започващи с конкретна буква
def AQ(url):
        req = urllib2.Request(ajaxurl, 'action=bntp_get_by_letter&programata_header_nonce='+nfn+'&letter='+url)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        #print data
        #jsonrsp = json.loads(data[:-1])
        #data = urllib.unquote_plus(data)
        #print jsonrsp['html'].decode('unicode_escape','ignore')
        
        match = re.compile('<div><a href="(.+?)" title="(.+?)" class="azbuchnik-link"><img src="(.+?)" alt=').findall(data.replace("\\", ""))
        for href, title, img in match:
            #print href
            addDir(title.replace("u", "\\u").decode('unicode_escape', 'ignore').encode('utf8', 'ignore'),href,7,img)
        

#Разлистване епизодите на дадено предаване или сериал
def LIST(url):
        #title, show, img = url.split("@")
        req = urllib2.Request(ajaxurl, 'action=bntp_get_by_term&programata_header_nonce='+nfn+'&terma='+url) #За още 40 епизода добавяме  &offset=40 към заявката
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        #print data
        
        #match = re.compile('<a href=\\"(.+?)" title=\\"(.+?)"><img src=\\"(.+?)"').findall(data.replace("\\", ""))
        match = re.compile('<img src=\\"(.+?)" alt=\\"(.+?)" \\/><\\/a><p><a href=\\"(.+?)"').findall(data.replace("\\", ""))
        for img, title, href in match:
            if not '<'in title.replace("u", "\\u").decode('unicode_escape', 'ignore').encode('utf8', 'ignore'):
                addLink(title.replace("u", "\\u").decode('unicode_escape', 'ignore').encode('utf8', 'ignore').replace('&#034;', '"'),href,9,img)
        #addDir('Следваща страница>>',url+'&offset=40',7,'DefaultFolder.png')
        
        
#Разлистване на предаванията според канала на излъчване
def CHLIST(url):
        addDir('БНТ1','bnt1',20,'http://logos.kodibg.org/bnt1.png')
        addDir('БНТ2','bnt2',20,'http://logos.kodibg.org/bnt2.png')
        addDir('БНТ HD','bnthd',20,'http://logos.kodibg.org/bnthd.png')
        addDir('БНТ Свят','bntw',20,'http://logos.kodibg.org/bntworld.png')


#Разлистване на предаванията на даден канал
def CH(url):
        req = urllib2.Request(ajaxurl, 'action=bntp_get_by_channel_pr&programata_header_nonce='+nfn+'&realChannel='+url)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        #print data
        #jsonrsp = json.loads(data[:-1])
        #data = urllib.unquote_plus(data)
        #print jsonrsp['html'].decode('unicode_escape','ignore')
        
        match = re.compile('<div><a href="(.+?)" title="(.+?)" class="channel-link"><img src="(.+?)" alt=').findall(data.replace("\\", ""))
        for href, title, img in match:
            #print href
            addDir(title.replace("u", "\\u").decode('unicode_escape', 'ignore').encode('utf8', 'ignore'),href,7,img)


#Каталог с жанрове на предаванията
def CATSLIST(url):
        addDir('Новини','Новини',30,'DefaultFolder.png')
        addDir('Спорт','Спорт',30,'DefaultFolder.png')
        addDir('Актуални предавания','Актуални предавания',30,'DefaultFolder.png')
        addDir('Публицистика','Публицистика',30,'DefaultFolder.png')
        addDir('ШОУ и развлекателни','ШОУ и развлекателни',30,'DefaultFolder.png')
        addDir('Култура','Култура',30,'DefaultFolder.png')
        addDir('Музика','Музика',30,'DefaultFolder.png')
        addDir('Детски','Детски',30,'DefaultFolder.png')
        addDir('Инициативи','Инициативи',30,'DefaultFolder.png')
        addDir('Образование','Образование',30,'DefaultFolder.png')
        addDir('Религия и история','Религия и история',30,'DefaultFolder.png')


#Разлистване на предаванията от посочен жанр
def CATS(url):
        req = urllib2.Request(ajaxurl, 'action=bntp_get_post_by_main_cat&programata_header_nonce='+nfn+'&clickedCat='+url)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        #print data
        #jsonrsp = json.loads(data[:-1])
        #data = urllib.unquote_plus(data)
        #print jsonrsp['html'].decode('unicode_escape','ignore')
        
        #<a href="predavanyia#255" title="Спортна треска"><img src="http://bnt.bg/wp-content/uploads/2016/02/sportna_treska_NEW_400x225.png" alt=
        match = re.compile('<div><a href="(.+?)" title="(.+?)"><img src="(.+?)" alt=').findall(data)
        for href, title, img in match:
            #print href
            addDir(title.replace("u", "\\u").decode('utf-8', 'ignore').encode('utf8', 'ignore'),'http://imedia.bnt.bg/'+href,7,img)



#Разлистване на достъпните чрез timeshift записи
def LIVE(url):
        req = urllib2.Request(url)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        #print data

        match = re.compile('class="programata-chas">(.+?)</span><img src="(.+?)" alt="predavane" /><a class="time-shift-inner-link" href="(.+?)" title="(.+?)" data-date="(.+?)">').findall(data)
        for chas, img, href, title, date in match:
            match = re.compile('http://i.userstat.cdn.bg/dvr/(.+?)/').findall(href)
            for ch in match:
                addLinkS(ch+' '+date+ ' '+chas+' '+title,href,9,img)


#Категории съдържание в архива на БНТ
def ARCHIVELIST(url):
        addDir('Предавания','http://stend.in.bnt.bg:8081/a-ya',80,'DefaultFolder.png')
        addDir('Филми','http://imedia.bnt.bg/archive-films',81,'DefaultFolder.png')
        addDir('Сериали','http://imedia.bnt.bg/archive-serials',82,'DefaultFolder.png')


#Разлистване на предаванията в архива
def ARCHIVEP(url):
        req = urllib2.Request(ajaxurl, 'action=bntp_get_post_by_letter_all_archive&programata_header_nonce='+nfn+'&archiveLetter=%D0%92%D0%A1%D0%98%D0%A7%D0%9A%D0%98')
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        #print data
        #jsonrsp = json.loads(data[:-1])
        #data = urllib.unquote_plus(data)
        #print jsonrsp['html'].decode('unicode_escape','ignore')
        
        #<a href="predavanyia#138" title="№1 – Туризмът"><img src="http://bnt.bg/wp-content/uploads/2016/01/no1turizmyt.jpg" alt=
        match = re.compile('<div><a href="(.+?)" title="(.+?)"><img src="(.+?)" alt=').findall(data)
        for href, title, img in match:
            #print href
            if not '<'in title.replace("u", "\\u").decode('utf-8', 'ignore').encode('utf8', 'ignore'):
                addDir(title.replace("u", "\\u").decode('utf-8', 'ignore').encode('utf8', 'ignore'),'http://imedia.bnt.bg/'+href,7,img)

#Разлистване на филмите в архива
def ARCHIVEM(url):
        req = urllib2.Request(ajaxurl, 'action=get_all_filmi_real&programata_header_nonce='+nfn)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        #print data
        #jsonrsp = json.loads(data[:-1])
        #data = urllib.unquote_plus(data)
        #print jsonrsp['html'].decode('unicode_escape','ignore')
        
        #<a href="predavanyia#138" title="№1 – Туризмът"><img src="http://bnt.bg/wp-content/uploads/2016/01/no1turizmyt.jpg" alt=
        match = re.compile('<div><a href="(.+?)" title="(.+?)"><img src="(.+?)" alt=').findall(data)
        for href, title, img in match:
            #print href
            addLink(title.replace("u", "\\u").decode('utf-8', 'ignore').encode('utf8', 'ignore'),'http://imedia.bnt.bg/'+href,9,img)

#Разлистване на сериалите в архива
def ARCHIVES(url):
        req = urllib2.Request(ajaxurl, 'action=get_all_filmi&programata_header_nonce='+nfn)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        #print data
        #jsonrsp = json.loads(data[:-1])
        #data = urllib.unquote_plus(data)
        #print jsonrsp['html'].decode('unicode_escape','ignore')
        
        #<a href="predavanyia#138" title="№1 – Туризмът"><img src="http://bnt.bg/wp-content/uploads/2016/01/no1turizmyt.jpg" alt=
        match = re.compile('<div><a href="(.+?)" title="(.+?)"><img src="(.+?)" alt=').findall(data)
        for href, title, img in match:
            #print href
            addDir(title.replace("u", "\\u").decode('utf-8', 'ignore').encode('utf8', 'ignore'),'http://imedia.bnt.bg/'+href,7,img)


#БНТ на живо по интернет
def LIVETV(url):
        req = urllib2.Request(url)
        opener = urllib2.build_opener()
        f = opener.open(req)
        jsonrsp = json.loads(f.read())

        for tv in range(0, len(jsonrsp['streams'])):
            if 'БНТ' in jsonrsp['streams'][tv]['title'].encode('utf-8', 'ignore'):
                addLink(jsonrsp['streams'][tv]['title'].encode('utf-8', 'ignore'),jsonrsp['streams'][tv]['url'],jsonrsp['streams'][tv]['mode'],jsonrsp['streams'][tv]['cover'])


#Извличане на стриймове от Evolink/CDNBG
def EVOLINK(name,url,iconimage):
        file = ''
        file2 = ''
        streem = ''
        streem2 = ''
        streem3 = ''

        #Select streamer
        streamer = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14'] #, '15', '16', '17', '18', '19', '20'
        ns = random.choice(streamer)

        if 'edge' in url:
            streem = re.sub(r"edge\d", "edge" + ns, url)
        else:
            referrer, adres, port, token = url.split("-")

            #Заявка към страницата със стрийма
            req = urllib2.Request(adres)
            req.add_header('User-Agent', UA)
            req.add_header('Referer', referrer)
            response = urllib2.urlopen(req)
            data=response.read()
            response.close()
            #print 'EVOLINK: ' + data

            #Генерираме сами стрийма с нов сървър от loadbalancer-a
            match = re.compile('file": "(.+?)"').findall(data)
            for file in match:
                streem = 'rtmp://edge' + ns + '.cdn.bg:' + port + '/fls/_definst_/' + file + ' pageURL=' + adres + ' token=' + token + ' swfUrl=http://cdn.bg/eflash/jwplayer510/player.swf timeout=12'
            match2 = re.compile("sdata.src = '(.+?)';").findall(data)
            for file2 in match2:
                streem2 = file2 + '|User-Agent=Mozilla%2F5.0%20(iPhone%3B%20CPU%20iPhone%20OS%207_1_1%20like%20Mac%20OS%20X)%20AppleWebKit%2F537.51.2%20(KHTML%2C%20like%20Gecko)%20Version%2F7.0%20Mobile%2F11D201%20Safari%2F9537.53'
            match3 = re.compile("'file','(.+?)'").findall(data)
            for file3 in match3:
                streem3 = 'rtmp://edge' + ns + '.cdn.bg:' + port + '/fls/_definst_/' + file3 + ' pageURL=' + adres + ' token=' + token + ' swfUrl=http://cdn.bg/eflash/jwplayer510/player.swf timeout=12'
                #streem3 = streem3.replace('_1.stream','_2.stream')

        #print 'EVOLINK: ' + streem + streem2 + streem3
        STREAMPLAY(name,streem+streem2+streem3,'iconimage')





#Търсачка
def SEARCH(url):
        keyb = xbmc.Keyboard('', 'Търсачка')
        keyb.doModal()
        searchText = ''
        if (keyb.isConfirmed()):
            searchText = urllib.quote_plus(keyb.getText())
            searchText=searchText.replace(' ','+')
            searchText = searchText.encode('utf-8')
            
            req = urllib2.Request(ajaxurl, 'action=imedia_pure_search&programata_header_nonce='+nfn+'&word='+searchText+'&wheader=da&q_offset=0')
            req.add_header('User-Agent', UA)
            response = urllib2.urlopen(req)
            data=response.read()
            response.close()
            #print data
        
            #<div><a href="http://imedia.bnt.bg/videos/magna-aura-izgubeniyat-grad-epizod-13" title="Магна Аура - изгубеният град - епизод 13"><img src="http://imedia.bnt.bg/wp-content/uploads/2015/05/vlcsnap-2015-05-22-16h32m20s122.png"
            match = re.compile('<div><a href="(.+?)" title="(.+?)"><img src="(.+?)"').findall(data)
            for href, title, img in match:
                #print href
                addLink(title.replace("u", "\\u").decode('utf-8', 'ignore').encode('utf8', 'ignore'),href,9,img)
        else:
            addDir('Върнете се назад в главното меню за да продължите','','',"DefaultFolderBack.png")
            
        







#Зареждане на видео
def PLAY(name,url,iconimage):
        #print url
        
        req = urllib2.Request(url)
        req.add_header('User-Agent', UA)
        response = urllib2.urlopen(req)
        data=response.read()
        response.close()
        #print data
            
        match = re.compile("(http://.*.cdn.*wowza.+?)[\"']").findall(data)
        for stream in match:
            stream = stream.replace("manifest.f4m","playlist.m3u8")
            
        match = re.compile("data-main-video-link='(.+?)'>").findall(data)
        for stream in match:
            #print stream
            pass
        
        #xbmc.executebuiltin('Notification(%s, %s, %d, %s)'%('iMedia','Адрес на стрийма: '+stream, 29000, 'DefaultVideo.png'))
        stream = stream + '|User-Agent=stagefright'
        li = xbmcgui.ListItem(iconImage=iconimage, thumbnailImage=iconimage, path=stream)
        li.setInfo('video', { 'title': name })
        try:
            xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, xbmcgui.ListItem(path = stream))
        except:
            xbmc.executebuiltin("Notification('Грешка','Видеото липсва на сървъра!')")




#Отваряне на онлайн стрийм
def STREAMPLAY(name,url,thumbnail):
        #Избиране на стрийминг сървър за Load Balancing
        streamers = []
        if '||' in url:
            streamers.extend(url.split("||"))
            ns = random.choice(streamers)
        else:
            ns = url
        #Възпроизвеждане
        li = xbmcgui.ListItem(path=ns)
        li.setInfo('video', { 'title': name })
        try:
            xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, xbmcgui.ListItem(path = ns))
        except:
            xbmc.executebuiltin("Notification(Грешка,Изпратете log файла до разработчика!)")



#Модул за добавяне на отделно заглавие и неговите атрибути към съдържанието на показваната в Kodi директория - НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def addLink(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        liz.setProperty("IsPlayable" , "true")
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        return ok

#Модул за добавяне на отделно заглавие и неговите атрибути към съдържанието на показваната в Kodi директория - вариант със сортиране, специално за timeshift секцията
def addLinkS(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        liz.setProperty("IsPlayable" , "true")
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
        xbmcplugin.addSortMethod(int(sys.argv[1]), xbmcplugin.SORT_METHOD_LABEL_IGNORE_THE)
        return ok

#Модул за добавяне на отделна директория и нейните атрибути към съдържанието на показваната в Kodi директория - НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def addDir(name,url,mode,iconimage):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
        return ok


#НЯМА НУЖДА ДА ПРОМЕНЯТЕ НИЩО ТУК
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param



params=get_params()
url=None
name=None
iconimage=None
mode=None

try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        name=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass


#Списък на отделните подпрограми/модули в тази приставка - трябва напълно да отговаря на кода отгоре
if mode==None or url==None or len(url)<1:
        CATEGORIES()
    
elif mode==1:
        AQLIST(url)

elif mode==2:
        CHLIST(url)

elif mode==3:
        CATSLIST(url)

elif mode==4:
        LIVE(url)

elif mode==5:
        STREAMPLAY(name,url,iconimage)

elif mode==6:
        LIVETV(url)

elif mode==7:
        LIST(url)

elif mode==8:
        ARCHIVELIST(url)

elif mode==9:
        PLAY(name,url,iconimage)

elif mode==10:
        AQ(url)

elif mode==11:
        SEARCH(url)

elif mode==19:
        EVOLINK(name,url,iconimage)

elif mode==20:
        CH(url)

elif mode==30:
        CATS(url)

elif mode==80:
        ARCHIVEP(url)

elif mode==81:
        ARCHIVEM(url)

elif mode==82:
        ARCHIVES(url)


xbmcplugin.endOfDirectory(int(sys.argv[1]))
